---
title: 理想乡构筑手记（4）：新的域名及一些杂谈
date: 2025-02-22
slug: hello-chlor-me
featuredImage: https://img.viento.cc/cover/hello-chlor-me-cover.webp
categories:
  - 百草园
  - 逍遥游
tags:
  - 博客
  - 域名
series: 理想乡构筑手记
summary: 再水的话园子要发洪灾了……
description: 本文介绍了作者更换博客域名为`chlor.me`的来龙去脉，并详细讨论了各种域名后缀（TLD）的类型、特点和适用场景。作者首先讲述了新域名的由来，认为`chlor.me`更简洁、更贴合其网络身份。随后，文章详细介绍了更换域名所需的操作，包括301重定向、搜索引擎更新、备案等。最后，文章重点讨论了各种域名后缀，包括gTLD（原始gTLD和新gTLD）、ccTLD（半通用ccTLD、一般开放ccTLD、限制性ccTLD等）以及其他特殊用途的TLD。作者对独立博客选择域名后缀给出了建议，强调「喜欢」是首要原则，但不推荐使用免费域名、低价域名、年抛域名和二级域名（少数特殊情况除外）。总的来说，作者认为除了少数域名外，各种TLD在SEO方面表现相近，选择域名后缀主要看个人喜好和网站定位。
wikilinks: true
---

诸位老友，晚上好。这里是 Chlorine。

是的，小氯在继续清自己的废稿（悲）。

## `chlor.me` 的来历

说是来历，其实也没什么太多好说的。

小氯的第一个域名购买自园子诞生的当天，服务商为 Dynadot。域名本身没什么特别出彩的地方，`yoghurtlee.com`，我过去的英语名字加上最为人熟知的 `.com`。当时的小氯还不叫小氯，或者用一句看起来高深莫测的话来说，还没有形成一个完整的互联网身份架构。

后来，由于各种各样的原因，小氯陆续买了一大堆域名，由于贫穷，其中最贵的也就是 `.me`。也想过买一下 `.dev` 和 `.cl`（这是智利的 ccTLD，和小氯的名字的一种最简写法一致），不过最后还是没下手。

随着时间的推移，小氯对这个域名开始不那么满意了。第一个太长，第二个和小氯（Chlorine）以及园子的名字都没什么联系。不过由于一直没找到合适的替代，而且这个域名的 SEO 也养了有一阵了，所以也就一直没换。

然而，在园子一周年这个很适合做 BREAKING CHANGE 的时间点，小氯还是按捺不住了。于是，小氯又开始趁着摸鱼时想域名。

好的 `.com` 基本没戏了，所幸我对 `.com` 也没什么执念，换一个 TLD 也不错。奈何由于 Chlorine 这个词实在是太常见了，因此几乎没有什么可用的后缀，而好的变体同样抢手。小氯挑来挑去，挑了一个 `chloryn.com`。当时感觉还不错，但是过不了几天看着就不是很好了。斟酌了一段时间，最后用了 `chlor.me`。

这个域名的含义很明显，`chlor` 就是 `chlorine` 的简写，对于比较熟悉英语的老友，即使是没有联想到，也至少是 `chloride`，也差不多。这个词根也有「绿色」的意思，例如 Chlorophyll（叶绿素）。`.me` 是黑山的 ccTLD，广泛用于个人网站，例如大佬 Anthony Fu 的博客就是 `antfu.me` 。而且，这个域名也非常简短，这是蛮不容易的。别的不说，<https://chlor.me> 看着比 <https://yoghurtlee.com> 干净多了，`hi[at]chlor.me` 也比 `me[at]yoghurtlee.com` 短很多。

其实当初小氯挑出的两个是 `chlori.me` 和 `chlor.dev`。两个域名都挺有特点的：`chlori.me` 会显得可爱一点（但是不多），而且接近 Chlorine 的原始拼写；而 `chlor.dev` 就是很简洁硬朗的技术风格，不过 `.dev` 是不能备案的（没错，`.me` 可以，也不知道是什么时候改的）。最后思来想去，反正 `chlor` 和 Chlorine 的联系已经够明显了，`chlorime` 也容易让人读错，那干脆就 `chlor.me` 好了。

由于 Spaceship 和 Porkbun 的 New Price 都不便宜，因此我就直接在套路云注册了，也方便备案。不过 `.me` 比 `.com` 的续费贵一些（大概贵了 30r），也算是可以接受吧。~~其实可以把域名转出去续费几年之后转回来，只要不被套路云的备案核查检测到即可。~~

目前来说，小氯对这个域名相当满意，未来很长一段时间应该不会再有更改了。不过很有趣的是，这么短的一个域名，却似乎没有被任何人注册——至少是使用过——我在 Google、Bing、DuckDuckGo、Baidu 没有找到任何记录，Web Archive 也没有。或许是因为想到用 Chlorine 这个词做 Nickname 的人实在不多吧——毕竟，这个词本身也似乎不太适合做 Nickname。

## 更换域名的工作

换个域名所需要的操作还挺多的，这里简单备忘一下吧。

### 301

这个自不必说。这里小氯提供两种方式：Cloudflare 的 301 和 Vercel 的。

#### Cloudflare

在 Cloudflare 中选中你需要的域名，点击边栏的规则 - 页面规则，添加一个这样的页面规则即可。

![cloudflare-page-rules-301](https://img.viento.cc/20250222-cloudflare-page-rules-301.avif)

#### Vercel

把域名绑定到 Vercel，然后在重定向方式里面选择 301 即可。

### Google 和 Bing 的更改域名

这个事情挺难搞的。不是说操作，操作的话只需要登录 Google Search Console，按照[文档](https://support.google.com/webmasters/answer/9370220?hl=zh-Hans)的做就可以，Bing Webmaster Tools 也差不多。主要的问题是 SEO 的迁移很费时间，而且并不完全。

### Algolia Docsearch

给 Algolia 发个工单，再把爬虫配置的域名改了就可以了。

### 重新备案

如果您不打算备案，跳过这段即可。

我们需要再开一个 ICP 备案申请，网站名字可以和原本一样，这个不耽误事。公安备案的话，把原本信息的主域名 / 从域名改一下就好，交互式网站也不需要重新做安全评估。当然，各个地方管局的政策可能不一样，注意根据自己所在地区做评估。

### 更新加入的组织的域名

例如萌 ICP 和开往。这个一般不难。

### 更改各种社交网站的域名

废话。

### 通知链接你的网站和网页

这是件几乎不可能完全做到的事，大家各自尽力就好了，

## 关于各种域名后缀

开始之前我们有必要明确一个基本原则：**您喜欢是第一位**。如果一个域名您真的喜欢得不得了，那就别管小氯下面如何聒噪，买就好了。

我们首先科普一下，TLD 分几种。

TLD 的分类极其复杂，如果希望太长不看，那么大致可以分为通用顶级域（gTLD），国家和地区顶级域（ccTLD）和其他。具体说，可以分为（原始）通用顶级域（一般就简称为 gTLD）、（开放的）新通用顶级域（New gTLD）、赞助顶级域（sTLD）、国家和地区顶级域（ccTLD）、国际化国家和地区顶级域（IDN ccTLD）、品牌顶级域（Brand TLD）、互联网基础设施顶级域（ITLD）、测试顶级域（Test TLD）等。

### gTLD

gTLD 从出现的时间来说，大致可以分为原始 TLD 和新 TLD（New gTLD）；而从注册限制来说，大致可以分为开放注册和限制注册（虽说当然没有不允许注册的 gTLD，但是有几乎不允许的）。我们使用第一个分类方法吧。

#### 原始 TLD

这些域名都是互联网的老古董了，从域名这玩意出现开始就有了。最初它们都有限制，不过现在很多都开放了。

| TLD    | 原始用途                    | 现状               |
| ------ | ----------------------- | ---------------- |
| `.com` | Commercial，商业机构         | 几乎无任何限制，最通行的 TLD |
| `.org` | Organization，非营利组织      | 几乎无任何限制          |
| `.net` | Network，网络服务提供商         | 几乎无任何限制          |
| `.int` | International，国际条约组织    | 严格限制             |
| `.edu` | Education，（美国认可的）高等教育机构 | 严格限制             |
| `.gov` | Government，（美国）联邦政府     | 严格限制             |
| `.mil` | Military，（美国）军队         | 严格限制             |

这里我们能注册的就是前三个，这也是非常受欢迎的三个博客 TLD。如果您能注册到后四个，那您是大哥。

原始 gTLD 三剑客的最大优点大概就是经典，认可度极高，而且不算贵，目前市价也就是不到一百 CNY 一年。

#### 开放性的 New gTLD

这事说来话长。在 2013 年，ICANN 搞了个新通用顶级域名 (New gTLD) 计划，希望扩展一下 TLD 的疆域，其中对所有人开放注册的那部分就是我这里说的「开放性的 New gTLD」。

开放性的 New gTLD 的家族极其庞大，如果我们在这里一个一个介绍，那么水个几十万字肯定是没问题的。所以我们只举少数几个例子——（吸气）

`.click`, `.cyou`, `.icu`, `.link`, `.online`, `.one`, `.work`,  `.site`, `.space`, `.top`, `.website`, `.xyz`, `.accountant`, `.app`, `.art`, `.baby`, `.beauty`, `.blog`, `.book`, `.cafe`, `.club`, `.design`, `.dev`, `.doctor`, `.eco`, `.fashion`, `.film`, `.finance`, `.fit`, `.game`, `.green`, `.health`, `.law`, `.live`, `.makeup`, `.media`, `.moe`, `.movie`, `.music`, `.news`, `.page`, `.photography`, `.restaurant`, `.shop`, `.show`, `.ski`, `.social`, `.sport`, `.store`, `.tech`, `.travel`, `.video`, `.london`, `.nyc`, `.tokyo` , `.vip`, `.xin` ……

这些 TLD 的价格不是很统一，从便宜的 `.top`、`.vip`、`.work` 到贵得要命的选择一应俱全。不过和原始 gTLD 三剑客比，它们的价格一般都偏高。

我们举几个（我周围的小样本的）博客里面常见的吧：

##### `.top`

没什么特别的寓意，顶级的、顶上的。

##### `.xyz`

同样寓意不明，所以使用也比较广泛。最著名的应该是 Alphabet（Google 的母公司）的 `abc.xyz`（很合理啊）。

##### `.vip`

寓意明显。之所以传播比较广泛，主要是因为便宜。

##### `.dev`

开发，技术范的后缀。

##### `.icu`

其现在的含义和医院那个 Intensive Care Unit 关系不大，主要是 I See You 的意思。

##### `.moe`

「萌」的英语化，蛮可爱的域名后缀。

##### `.space`

个人空间？

##### `.blog`

看着是给博客设计的，实际上用的人不太多。

#### 赞助顶级域（sTLD）

也就是受到特定组织资助的 TLD，一般注册审核都比较严格，比如用于加泰罗尼亚文化的 `.cat`（没错，这个域名的意思真的不是「猫」）。

严格来说，此处说的是赞助性新顶级域，因为 `.edu` 这些也可以算是 sTLD。

#### 品牌顶级域（Brand TLD）

顾名思义，开放给特定品牌的 TLD，咱们不能注册。比如 `.google` 和 `.apple`。

### 国家和地区顶级域（ccTLD）

要来力（喜）

每个国家都有自己的两字母顶级域，根据 ISO 3166-1 国家和地区代码标准分配。此外一些地区和非国家实体也有，如香港的 `.hk` 和欧盟的 `.eu`。

#### 半通用 ccTLD

这些 ccTLD 已经极度普遍，以至于脱离了其原始的国家和地区含义，而被赋予了新的意义。我们举几个例子。

##### `.me`

来自黑山。由于和 `.me` 高度重合，因此广泛用于个人网站，例如我很喜欢举的例子，Anthony Fu 大佬的域名 `antfu.me`。园子目前的主域名也是 `.me`。

##### `.tv`

来自图瓦卢。没什么可说的，电视，因此用于电视、视频、流媒体，如 Bilibili 的短链 `b23.tv`，Bangumi 的 `bangumi.tv`。

##### `.fm`

来自密克罗尼西亚联邦。FM 和一种有点古老的事物——调频广播（Frequency Modulation）的简写一样，因此可以用于广播电台、音乐平台、播客平台等。

##### `.ai`

来自安圭拉。也没什么可说的，人工智能。比如 Anthropic 的 `claude.ai`，马牢板的 `x.ai` 等。这个 TLD 奇贵，导致安圭拉很大一部分收入都是卖域名得到的。

##### `.io`

来自英属印度洋领地（BIOT）。[^1]由于和输入 / 输出（Input / Output）以及互联网组织（Internet Organization）简写一致，在技术领域非常受欢迎。当然，价格也比较贵。

##### `.cc`

来自科科斯（基林）群岛。由于其可解读性过高，已经成为了类似 `.com` 的泛用域名。

##### `.co`

来自哥伦比亚。常被视为 `.com` 的替代品，用于各类公司和商业网站。

#### 一般的开放 ccTLD

这些 ccTLD 不像上面的 TLD 那么通行，但是注册的限制较少。例如 `.fi`（芬兰），`.is`（冰岛）等。

#### 限制性 ccTLD

这些 ccTLD 的注册有一定限制，如 `.cn` 必须要具有中国大陆身份并实名认证，`.jp` 必须要在日本拥有物理地址。其中也有一些限制比较严格的，例如梵蒂冈的 ccTLD `.va` 只被允许用于与圣座有关的网站，不对外开放注册。

#### 国际化国家和地区顶级域（IDN ccTLD）

简单来说就是本地化的国家顶级域，例如 `.中国`，`.рф`，`.مصر`。实际操作的时候一般使用 Punycode 表示。

### 其他

下面的 TLD 大家肯定都是注册不了的，看个乐子就行。

#### 互联网基础设施顶级域

这个群体目前只有一个成员，就是 `.arpa`。

ARPA 是「地址和路由参数区域」的简写，其专门用于互联网的基础设施，如 `in-addr.arpa`（反向 DNS 至 IPv4）、`ip6.arpa`（反向 DNS 至 IPv6）等。其注册由 IANA 严格控制，不对外开放。

……当然，这也不是说 `.arpa` 就一定是基础设施，也有少数显眼包拿这个域名整活，比如有一个跑在 `.arpa` 的 GoToSocial 实例——<https://1.6.0.0.8.0.0.b.e.d.0.a.2.ip6.arpa/>。小氯对此不评价。

#### 测试顶级域（tTLD）

比如 `.localhost`，`.invalid`，`.test` 等。这些 TLD 只在测试环境使用，不会被解析到公共 DNS。

#### 本地网络顶级域

即 `.local`，主要用于多播 DNS（mDNS）。它在 RFC 6762 中被指定为用于本地网络名称解析的特殊域名。

#### 无效顶级域

>  还有这玩意？

理论上来说，有。例如，你可以通过修改 host 文件实现本地的任意的 TLD，例如 `.chlorinechan` 也是可以的。

## 独立博客用什么域名后缀？

如前文所说挺久之前，小氯曾经专门写过[[独立博客选什么域名后缀？|一篇文章]]将这个问题，虽说以小氯现在的眼光看那是篇水文，但是其中一些观点还是有用的。

这里小氯也更新一下自己的观点吧。总体而言就是这么几个原则：

- 非常不推荐使用免费域名
- 不推荐使用低价域名（如 `.top`，`.vip`，`.ru`，`.de`，`.work`，数字 `.xyz` 等）
- 不推荐使用年抛域名
- 除了少数特殊存在外，不推荐使用二级域名

### 非常不推荐使用免费域名

免费的域名大概有 `.tk`（托克劳的 ccTLD），`.cf`（中非的 ccTLD），`.ml`（马里的 ccTLD），`.ga`（加蓬的 ccTLD）和 `.gq`（赤道几内亚的 ccTLD）几个，由大名鼎鼎的 Freenom 运营。不过现在 Freenom 停止免费域名注册了，不知道以后会怎么样。

免费的东西，世界各地的人们肯定都喜欢薅，就拿 `.tk` 来说，根据 [Domain Name Stat](https://domainnamestat.com/statistics/tld/others) 的数据，`.tk` 在所有 TLD 中的注册数量达到了惊人的 27,547,091 个，仅次于 `.com` 和 `.cn`。

当然，咱们良家少年 / 少女喜欢，那些不怀好意的人也喜欢。`.tk` 被大量用于钓鱼、诈骗等非法网站，跟 `.tk` 的名声比，缅北都算是童叟无欺的。而且，有句话说得好，免费的才是最贵的。谁知道哪一天，免费的域名就要收费了，或者出了什么奇奇怪怪的政策。

### 不推荐使用低价域名

这个理由嘛，和前面基本一样。毕竟，不用花钱的域名和一年 1 CNY 的域名其实也差不太多。嗯……尤其是 `.top`，虽然说小氯的老友们用 `.top` 的还蛮多的。VX 已经到了看见 `.top ` 就想拦截的程度了。就连 `.top ` 的注册局（江苏邦宁科技有限公司）都被 ICANN 警告了，您想想这个 TLD 的名声能好到哪去呢。

### 不推荐使用年抛域名

年抛域名是对一类首年价格低廉但是续费价格比较高昂的域名的统称，例如普通的 `.xyz`、`.shop`、`.love` 等（很大一部分新 TLD 都属于这个范畴，只不过高昂的程度不同）。

年抛域名的名声也不太好，原因很明显：哪些人会隔一段时间就换个域名呢？~~那当然是某只元素娘啦~~自然是那些干完坏事就换个壳子重生的非法网站。

### 一般不推荐使用二级域名

这个事情也比较好理解，连个自己的顶级域名都不想买，那很难让人相信你的专业性（虽然这个联想有点无厘头）。而且许多二级域名是免费的，例如 `.us.kg` ——嗯，自然也是被薅秃了。不过有一些二级域名除外，比如 `.github.io`（GitHub Pages 的二级域名），以及有特殊用途的 `.js.org`，`.com.cn` ——不过这些二级域名也很少用在博客上就是了。

……那么 `.vercel.app` 和 `.netlify.app` 呢？

说实话，咱能别用这个，还是别用了吧……

---

余下的域名，小氯的观点是：**喜欢哪个用哪个**。因为除开上面提到的这些牛鬼蛇神，现在的各种 TLD 在 SEO 方面的表现其实差不多，主要看的还是你的网站和内容。只是说，`.com` 最为大众所熟知而已，如果你的网站是完全大众导向的（并且你假定你的目标读者中大部分人都是互联网文盲），那么 `.com` 才会占有比较大的优势。

[^1]: 2024 年 10 月 3 日，英国宣布将英属印度洋领地主权将移交给毛里求斯。按照 ICANN 的规定，这意味着 `.io` 域名将会在不久的未来消失。